VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFreeDB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const INTERNET_SERVICE_HTTP = 3
Private Const INTERNET_DEFAULT_HTTP_PORT = 80
Private Const INTERNET_DEFAULT_HTTPS_PORT = 443
Private Const INTERNET_DEFAULT_SOCKS_PORT = 1080
Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Private Const INTERNET_OPEN_TYPE_DIRECT = 1
Private Const INTERNET_OPEN_TYPE_PROXY = 3
Private Const INTERNET_OPTION_CONNECT_TIMEOUT = 2
Private Const INTERNET_OPTION_RECEIVE_TIMEOUT = 6
Private Const INTERNET_OPTION_SEND_TIMEOUT = 5
Private Const INTERNET_OPTION_USERNAME = 28
Private Const INTERNET_OPTION_PASSWORD = 29
Private Const INTERNET_OPTION_PROXY_USERNAME = 43
Private Const INTERNET_OPTION_PROXY_PASSWORD = 44
Private Const INTERNET_FLAG_NO_AUTH = &H40000
Private Const INTERNET_FLAG_KEEP_CONNECTION = &H400000
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const HTTP_QUERY_CONTENT_TYPE = 1
Private Const HTTP_QUERY_CONTENT_LENGTH = 5
Private Const HTTP_QUERY_EXPIRES = 10
Private Const HTTP_QUERY_LAST_MODIFIED = 11
Private Const HTTP_QUERY_PRAGMA = 17
Private Const HTTP_QUERY_VERSION = 18
Private Const HTTP_QUERY_STATUS_CODE = 19
Private Const HTTP_QUERY_STATUS_TEXT = 20
Private Const HTTP_QUERY_RAW_HEADERS = 21
Private Const HTTP_QUERY_RAW_HEADERS_CRLF = 22
Private Const HTTP_QUERY_FORWARDED = 30
Private Const HTTP_QUERY_SERVER = 37
Private Const HTTP_QUERY_USER_AGENT = 39
Private Const HTTP_QUERY_SET_COOKIE = 43
Private Const HTTP_QUERY_REQUEST_METHOD = 45
Private Const HTTP_STATUS_DENIED = 401
Private Const HTTP_STATUS_PROXY_AUTH_REQ = 407
Private Const HTTP_QUERY_FLAG_REQUEST_HEADERS = &H80000000
Private Const HTTP_QUERY_FLAG_NUMBER = &H20000000
Private Const HTTP_ADDREQ_FLAG_ADD_IF_NEW = &H10000000
Private Const HTTP_ADDREQ_FLAG_ADD = &H20000000
Private Const HTTP_ADDREQ_FLAG_REPLACE = &H80000000
Private Const INTERNET_OPTION_VERSION = 40

Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" ( _
    ByVal sCallerName As String, ByVal lAccessType As Long, _
    ByVal sProxyName As String, ByVal sProxyBypass As String, _
    ByVal lFlags As Long _
) As Long

Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" ( _
    ByVal hInternetSession As Long, ByVal sServerName As String, _
    ByVal nServerPort As Integer, ByVal sUsername As String, _
    ByVal sPassword As String, ByVal lService As Long, _
    ByVal lFlags As Long, ByVal lContext As Long _
) As Long

Private Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" ( _
    ByVal hInternetSession As Long, ByVal sUrl As String, _
    ByVal sHeaders As String, ByVal lLength As Long, _
    ByVal lFlags As Long, ByVal lContext As Long _
) As Long

Private Declare Function InternetReadFile Lib "wininet.dll" ( _
    ByVal hFile As Long, ByVal sBuffer As String, _
    ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long _
) As Integer

Private Declare Function InternetCloseHandle Lib "wininet.dll" ( _
    ByVal hInternetHandle As Long _
) As Boolean

'**************************************
'** Function: FreeDBQuery
'** Returns: Long
'**          -1: failed
'**           0: different results in different categories returned, categories in ret()
'**              (not possible for category <> "")
'**           1: ok, result in ret()
'** Usage: asks the FreeDB online database for music CD data
'**************************************
Public Function FreeDBQuery(ByVal DrvID As String, ByRef ret() As String, Optional ByVal category As String = "") As Long
    'On Error Resume Next
    Dim cats() As String
    Dim i As Integer, j As Integer, k As Integer
    Dim oldresult() As String
    Dim retcnt As Integer: retcnt = -1

    ReDim cats(10)
    cats(0) = "blues": cats(1) = "classical"
    cats(2) = "country": cats(3) = "data"
    cats(4) = "folk": cats(5) = "jazz"
    cats(6) = "misc": cats(7) = "newage"
    cats(8) = "reggae": cats(9) = "rock"
    cats(10) = "soundtrack"

    If Not category = vbNullString Then
        If InStr(1, category, "- ") > 0 Then category = Left$(category, InStr(1, category, " - ") - 1)
        FreeDBQuery = Abs(Query(DrvID, category, ret))
        Exit Function
    End If

    For i = 0 To UBound(cats)
        If Query(DrvID, cats(i), oldresult) Then
            retcnt = retcnt + 1
            ReDim Preserve ret(retcnt)
            ret(retcnt) = cats(i) & " - " & oldresult(0)
        End If
    Next

    If retcnt = -1 Then
        FreeDBQuery = -1
    ElseIf retcnt > 0 Then
        FreeDBQuery = 0
    ElseIf retcnt = 0 Then
        ReDim ret(UBound(oldresult))
        ret = oldresult
        FreeDBQuery = 1
    End If
End Function

Private Function Query(ByVal DrvID As String, ByVal cat As String, ByRef ret() As String) As Boolean
    On Error GoTo ErrH

    Dim sUrl As String, sData As String
    Dim sArtist As String, sAlbum As String
    Dim sTitle As String, sTracks As String
    Dim sTrackTitles() As String
    Dim i As Integer

    'prepare the url
    sUrl = "http://freedb.freedb.org/~cddb/cddb.cgi?cmd=cddb+read+" & cat & "+"
    sUrl = sUrl & CDDB_Disc_ID(DrvID)
    sUrl = sUrl & "&hello=cCD+host.com+cCD.cls+1.0&proto=1"
    'open the url and get its contents
    sData = OpenURL(sUrl)
    'error?
    If sData = vbNullString Then Query = False: Exit Function

    'Artist / Album
    sTitle = Mid(sData, InStr(1, sData, "DTITLE") + 7)
    sTitle = Left(sTitle, InStr(1, sTitle, vbCrLf) - 1)
    'Artist / Album
    sArtist = Left(sTitle, InStr(1, sTitle, "/") - 2)
    sAlbum = Right(sTitle, Len(sTitle) - Len(sArtist) - 3)

    'cut out the tracks
    sTracks = Mid(sData, InStr(1, sData, "TTITLE"), InStr(1, sData, "EXTD") - InStr(1, sData, "TTITLE"))
    'Tracktitle
    sTrackTitles = Split(sTracks, vbCrLf)
    For i = 0 To UBound(sTrackTitles) - 1
        'remove descriptors
        sTrackTitles(i) = Mid(sTrackTitles(i), InStr(1, sTrackTitles(i), "=") + 1)
    Next

    'return the data to the ByRef parameter
    ReDim ret(1 + UBound(sTrackTitles))
    ret(0) = sArtist: ret(1) = sAlbum

    For i = 0 To UBound(sTrackTitles) - 1
        ret(i + 2) = sTrackTitles(i)
    Next

    Query = True

ErrH:
    'RaiseEvent status(STR_STAT_READY, GetStr(STR_STAT_READY))
End Function

'From UFREEDB source
Private Function OpenURL(ByVal sUrl As String) As String
    Dim hOpen       As Long
    Dim hOpenUrl    As Long
    Dim lBytesRead  As Long
    Dim strBuffer   As String * 2048
    Dim strData     As String

    On Error GoTo errChk

    hOpen = InternetOpen("uFreedb", INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)

    If (hOpen <> 0) Then
        hOpenUrl = InternetOpenUrl(hOpen, sUrl, vbNullString, 0, INTERNET_FLAG_RELOAD, 0)

        If (hOpenUrl <> 0) Then
            Do
                strBuffer = vbNullString
                Call InternetReadFile(hOpenUrl, strBuffer, Len(strBuffer), lBytesRead)
                strData = strData & Left$(strBuffer, lBytesRead)
            Loop Until (lBytesRead = 0)

            InternetCloseHandle (hOpenUrl)

        Else
'            RaiseEvent ProtocolError(Err.LastDllError, ErrDesc(Err.LastDllError))
        End If

        InternetCloseHandle (hOpen)

    Else
'        RaiseEvent ProtocolError(Err.LastDllError, ErrDesc(Err.LastDllError))
    End If

    OpenURL = strData
    Exit Function

errChk:
'    If (enumLanguage = GERMAN) Then
'        RaiseEvent ProtocolError(8888, "Unbekannter Fehler")
'    ElseIf (enumLanguage = FRENCH) Then
'        RaiseEvent ProtocolError(8888, "Erreur Inconnue")
'    Else
'        RaiseEvent ProtocolError(8888, "UnKnown Error")
'    End If

    If (hOpen <> 0) Then InternetCloseHandle (hOpen)
End Function
