VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cGrab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event ReadProgress(ByVal percent As Long, ByVal CurrTrk As Integer)

'**************************************
'** Function: SaveAudioTrack
'** Returns: Long
'** Usage: saves a track to a wave file
'**************************************
Public Function SaveAudioTrack(ByVal DrvID As String, ByVal TrkNum As Integer, _
                               ByVal sFile As String) As Long
    On Error GoTo ErrHandle

    Dim trknfo As New cTrackInfo
    Set trknfo = TrackInfo(DrvID, TrkNum)   ' get information about the track
    Dim buffer(2352 * 12 - 1) As Byte       ' buffer for 12 raw sectors
    Dim i As Long
    Dim FF As Integer: FF = FreeFile

    'open the output file
    Open sFile For Binary As #FF
        WriteWavHdr FF, trknfo.Length * 2352    ' write a CDDA wave header
        'read the sectors to the file
        For i = trknfo.StartLBA To trknfo.EndLBA Step ((UBound(buffer) + 1) / 2352)
'            If bCancel Then
'                'process canceled by user?
'                bCancel = False
'                SaveAudioTrack = 2
'                Exit Function
'            End If

            'read a bunch of sectors to the file
            If Not ReadCD(DrvID, i, (UBound(buffer) + 1) / 2352, VarPtr(buffer(0)), UBound(buffer), &HF8) Then
                SaveAudioTrack = 0
                Close #FF
                Exit Function
            End If

            Put #FF, , buffer
            RaiseEvent ReadProgress(Fix(((i - trknfo.StartLBA) / (trknfo.EndLBA - trknfo.StartLBA)) * 100), TrkNum)
            DoEvents
        Next
    Close #FF

    'did it
    SaveAudioTrack = 1
    Exit Function

ErrHandle:
    'error...
    Close #FF
    SaveAudioTrack = -1
End Function

'**************************************
'** Function: SaveDataTrack
'** Returns: Long
'** Usage: saves a track to a iso file
'**************************************
Public Function SaveDataTrack(ByVal DrvID As String, ByVal TrkNum As Integer, ByVal sFile As String) As Long
    On Error GoTo ErrHandle

    Dim trknfo As New cTrackInfo
    Set trknfo = TrackInfo(DrvID, TrkNum)   ' get information about the track
    Dim buffer(2048 * 12 - 1) As Byte       ' buffer for 12 mode-1 sectors
    Dim i As Long
    Dim FF As Integer: FF = FreeFile

    'open the output file
    Open sFile For Binary As #FF
        'save the sectors to the file
        For i = trknfo.StartLBA To trknfo.EndLBA Step ((UBound(buffer) + 1) / 2048)
'            If bCancel Then
'                'process canceled by the user?
'                bCancel = False
'                SaveDataTrack = 2
'                Exit Function
'            End If

            'read a bunch of sectors
            If Not Read10(DrvID, i, VarPtr(buffer(0)), UBound(buffer), (UBound(buffer) + 1) / 2048) Then
                Close #FF
                SaveDataTrack = 0
                Exit Function
            End If

            'and write it to the file
            Put #FF, , buffer
            RaiseEvent ReadProgress(Fix(((i - trknfo.StartLBA) / (trknfo.EndLBA - trknfo.StartLBA)) * 100), TrkNum)
            DoEvents
        Next
    Close #FF

    'did it
    SaveDataTrack = 1
    Exit Function

ErrHandle:
    'error...
    Close #FF
    SaveDataTrack = -1
End Function

Public Function SaveBinCue(ByVal DrvID As String, ByVal sBinImg As String, ByVal session As Byte) As Long
    Const SectorSize As Double = 2352
    Const NumSectors As Double = 20 * SectorSize

    Dim tracks() As Byte
    Dim trknfo As cTrackInfo
    Dim CDNfo As cCDInfo
    Dim PreGap As t_CDCurrPos
    Dim sessnfo As cSessInfo
    Dim TrkCnt As Byte, i As Long, j As Long
    Dim PreGapBuf(2351) As Byte, ReadBuf(NumSectors - 1) As Byte, RestBuf() As Byte
    Dim FF As Integer: FF = FreeFile
    Dim FF2 As Integer: FF2 = FreeFile + 1
    Dim PreGapLen As Long, TotalPreGapLen As Long
    Dim LastTrkEndLBA As Long

    'disc present?
    If IsDiscPresent(DrvID) < 1 Then _
        SaveBinCue = -6: Exit Function

    'drive ready?
    If Not TestUnitReady(DrvID) Then _
        SaveBinCue = -5: Exit Function

    'get information about the disc
    Set CDNfo = CDInfo(DrvID)

    'get information about the selected session
    Set sessnfo = SessionInfo(DrvID, session)

    'disc empty?
    If CDNfo.DiscStatus = STAT_EMPTY Then _
        SaveBinCue = -4: Exit Function

    'open the binary image
    Open sBinImg For Binary As #FF

    'open the cue sheet
    Open GetPath(sBinImg) & GetFilename(sBinImg) & ".cue" For Output As #FF2

    'write the cuesheet header
    Print #FF2, "FILE " & """" & GetFilename(LCase(sBinImg)) & """" & " BINARY"

    'go through every track on the disc
    For TrkCnt = sessnfo.FirstTrack To sessnfo.LastTrack

        'get info on the curren track
        Set trknfo = TrackInfo(DrvID, TrkCnt)

        i = trknfo.StartLBA

        PreGapLen = 1

        If Seek10(DrvID, i - 1) Then

            If trknfo.StartLBA > LastTrkEndLBA Then

                'get Q SubCh information
                If Not ReadSubChannel(DrvID, True, True, 1, 0, VarPtr(PreGap), Len(PreGap)) Then _
                    Close #FF2: Close #FF: SaveBinCue = -2: Exit Function

                'Pre-Gap?
                If PreGap.IndexNum = 0 Then
                    'yes!

                    'save the Pre-Gap
                    j = trknfo.StartLBA - 1
                    Do While Not j = -1

                        DoEvents

'                        If bCancel Then
'                            'user canceled the process?
'                            bCancel = False
'                            Close #FF: Close #FF2
'                            SaveBinCue = 0
'                            Exit Function
'                        End If

                        'read a sector from the gap
                        If Not ReadCD(DrvID, j, 1, VarPtr(PreGapBuf(0)), UBound(PreGapBuf), &HF8) Then
                            j = -1
                            Exit Do
                        Else
                            j = j - 1
                        End If
    
                        RaiseEvent ReadProgress(Fix(((i + j) / CDNfo.Size) * 100), TrkCnt)
    
                        Seek10 DrvID, j

                        'get Q SubCh information
                        If Not ReadSubChannel(DrvID, True, True, 1, 0, VarPtr(PreGap), Len(PreGap)) Then _
                            Close #FF2: Close #FF: SaveBinCue = -2: Exit Function

                        'if we read in a gap, write the gap buffer to the file
                        If PreGap.IndexNum = 0 Then
                            Put #FF, , PreGapBuf
                            PreGapLen = PreGapLen + 1
                        Else
                            'we finished reading the gap!
                            j = -1
                        End If

                    Loop

                End If

            End If

        End If


        'go for the track!!
        If trknfo.Track = sessnfo.LastTrack Then
            trknfo.EndLBA = trknfo.EndLBA - 150
        End If
        For i = i To trknfo.EndLBA Step (UBound(ReadBuf) + 1) \ 2352

            DoEvents

'            If bCancel Then
'                'user canceled the process?
'                bCancel = False
'                Close #FF: Close #FF2
'                SaveBinCue = 0
'                Exit Function
'            End If

            'read 10 sectors
            If Not ReadCD(DrvID, i, (UBound(ReadBuf) + 1) \ 2352, VarPtr(ReadBuf(0)), UBound(ReadBuf), &HF8) Then
                Close #FF2: Close #FF
                SaveBinCue = -1:
                'Err.Raise 4000
                Exit Function
            End If

            RaiseEvent ReadProgress(Fix(((i - sessnfo.FirstTrackLBA) / sessnfo.Size) * 100), TrkCnt)

            'write them to the image
            Put #FF, , ReadBuf

            If i + ((UBound(ReadBuf) + 1) \ 2352) > trknfo.EndLBA Then Exit For

        Next i

        'forgot any sectors?
        If i < trknfo.EndLBA Then

            'redimension the rest buffer
            ReDim RestBuf((trknfo.EndLBA - i) * 2352 - 1)

            'get the rest of the track
            If Not ReadCD(DrvID, i, (UBound(RestBuf) + 1) \ 2352, VarPtr(RestBuf(0)), UBound(RestBuf), &HF8) Then
                Close #FF2: Close #FF
                SaveBinCue = -1
                'Err.Raise 40000
                Exit Function
            End If

            'and finally write it to the file
            Put #FF, , RestBuf

        End If

        'print Cue Sheet track entry
        Print #FF2, "  TRACK " & format(TrkCnt - sessnfo.FirstTrack + 1, "00") & " " & SectorMode2StrBin(GetSectorMode(DrvID, trknfo.StartLBA))
        If PreGapLen > 1 Then Print #FF2, "    INDEX 00 " & LBA2MSF(trknfo.StartLBA - 150 - sessnfo.FirstTrackLBA)
        Print #FF2, "    INDEX 01 " & LBA2MSF(trknfo.StartLBA + (IIf(PreGapLen > 1, PreGapLen, 0)) + TotalPreGapLen - 150 - sessnfo.FirstTrackLBA)

        LastTrkEndLBA = trknfo.EndLBA
        If PreGapLen > 1 Then
            TotalPreGapLen = TotalPreGapLen + PreGapLen
        End If

    Next TrkCnt

    Close #FF2: Close #FF
    SaveBinCue = 1
End Function

Private Function SectorMode2StrBin(ByVal sMode As e_SectorModes) As String
    Select Case sMode
        Case MODE_AUDIO: SectorMode2StrBin = "AUDIO"
        Case MODE_MODE1: SectorMode2StrBin = "MODE1/2352"
        Case MODE_MODE2: SectorMode2StrBin = "MODE2/2352"
        Case MODE_MODE2_FORM1: SectorMode2StrBin = "MODE2/2352"
        Case MODE_MODE2_FORM2: SectorMode2StrBin = "MODE2/2352"
    End Select
End Function
