VERSION 5.00
Begin VB.Form frmWriteOptions 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Write-Options"
   ClientHeight    =   3075
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5655
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmWriteOptions.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3075
   ScaleWidth      =   5655
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame Frame1 
      Caption         =   "Options"
      Height          =   1455
      Left            =   255
      TabIndex        =   6
      Top             =   1080
      Width           =   5145
      Begin VB.CheckBox chkBurnProof 
         Caption         =   "Enable BURN-Proof"
         Enabled         =   0   'False
         Height          =   285
         Left            =   180
         TabIndex        =   10
         ToolTipText     =   "Enable Buffer-UnderRuN proof technology"
         Top             =   270
         Width           =   4515
      End
      Begin VB.CheckBox chkTestMode 
         Caption         =   "Write in Test-Mode"
         Enabled         =   0   'False
         Height          =   285
         Left            =   180
         TabIndex        =   9
         ToolTipText     =   "Enable Test-Mode to turn of the laser during writing"
         Top             =   540
         Width           =   4515
      End
      Begin VB.CheckBox chkFinalize 
         Caption         =   "Finalize disc"
         Height          =   285
         Left            =   180
         TabIndex        =   8
         ToolTipText     =   "Write a Lead-Out so no more data can be written to the disc"
         Top             =   810
         Value           =   1  'Checked
         Width           =   4515
      End
      Begin VB.CheckBox chkEject 
         Caption         =   "Eject disc after writing"
         Height          =   285
         Left            =   180
         TabIndex        =   7
         ToolTipText     =   "Eject the disc after writing"
         Top             =   1080
         Value           =   1  'Checked
         Width           =   4515
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   285
      Left            =   4215
      TabIndex        =   5
      Top             =   2700
      Width           =   1185
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Start"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   2685
      TabIndex        =   4
      Top             =   2700
      Width           =   1455
   End
   Begin VB.ComboBox cboSpeeds 
      Height          =   315
      Left            =   885
      Style           =   2  'Dropdown List
      TabIndex        =   3
      ToolTipText     =   "Select a writing-speed (Warning: higher speeds could cause a buffer-underrun!)"
      Top             =   585
      Width           =   1995
   End
   Begin VB.ComboBox cboDrvs 
      Height          =   315
      Left            =   885
      Style           =   2  'Dropdown List
      TabIndex        =   1
      ToolTipText     =   "Device to use for writing"
      Top             =   180
      Width           =   4515
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "You should select only slow speeds!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   195
      Left            =   2910
      TabIndex        =   11
      Top             =   630
      Width           =   2550
   End
   Begin VB.Label lblSpeed 
      AutoSize        =   -1  'True
      Caption         =   "Speed:"
      Height          =   195
      Left            =   195
      TabIndex        =   2
      Top             =   630
      Width           =   615
   End
   Begin VB.Label lblDrv 
      AutoSize        =   -1  'True
      Caption         =   "Drive:"
      Height          =   195
      Left            =   270
      TabIndex        =   0
      Top             =   230
      Width           =   540
   End
End
Attribute VB_Name = "frmWriteOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim bTestMode As Boolean
Dim unloading As Boolean

Private Sub cboDrvs_Click()
    Dim DrvID As String, MaxSpeed As Long, i As Long
    DrvID = drives.Item(cboDrvs.ListIndex + 1).DriveID

    'get the max. writing speed
    MaxSpeed = drives.Item(cboDrvs.ListIndex + 1).Info.MaxWriteSpeed
    'add speed multiplicators
    cboSpeeds.Clear
    For i = 2 To MaxSpeed / 176.5 Step 2
        cboSpeeds.AddItem i & "x (" & i * 176.5 & " kb/s)", 0
        cboSpeeds.ItemData(cboSpeeds.ListCount - 1) = i * 176.5
    Next
    'add max. writing speed descriptor
    cboSpeeds.AddItem "Max.", 0
    cboSpeeds.ListIndex = cboSpeeds.ListCount - 1

    'test-mode allowed?
    If bTestMode Then
        'drive supports test-mode?
        If drives.Item(cboDrvs.ListIndex + 1).Info.TestMode Then
            chkTestMode.Enabled = True
        Else
            chkTestMode.Enabled = False
        End If
    End If

    'BURN-Proof supported by drive?
    If drives.Item(cboDrvs.ListIndex + 1).Info.BURNProof Then
        chkBurnProof.Enabled = True
    Else
        chkBurnProof.Enabled = False
    End If
End Sub

Private Sub cmdCancel_Click()
    WrtDrvID = -1
    Unload Me
End Sub

Public Sub ShowDialog(ByVal AllowTestMode As Boolean)
    Dim i As Integer
    Dim enumdrvs As New cEnumDrvs
    Set drives = New cDrives

    'test-mode allowed by project?
    bTestMode = AllowTestMode

    'get the newest data from the drives
    '
    'some drives may change the maximal writing speed
    'depending on the inserted media
    enumdrvs.EnumerateDrives drives

    For i = 1 To drives.Count
        With drives.Item(i)
            'only show cd-writers
            If .Info.WriteCDR Or .Info.WriteCDRW Then
                cboDrvs.AddItem .DrvChr & ":\ " & .Vendor & " " & .Product & " " & .Revision
            End If
        End With
    Next
    cboDrvs.ListIndex = 0

    Me.Show vbModal, frmMain

    While Not unloading
        DoEvents
    Wend
End Sub

Private Sub cmdGo_Click()
    WrtDrvID = drives.Item(cboDrvs.ListIndex + 1).DriveID
    SetCDSpeed WrtDrvID, 0, cboSpeeds.ItemData(cboSpeeds.ListIndex), True
    bEjectAfterWrite = chkEject.value = 1
    bUseTestMode = chkTestMode.value = 1
    bUseBURNProof = chkTestMode.value = 1
    bFinalizeDisc = chkFinalize.value = 1
    Unload Me
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = 0 Then WrtDrvID = -1
End Sub

Private Sub Form_Unload(Cancel As Integer)
    unloading = True
End Sub
