Attribute VB_Name = "modEnums"
Option Explicit

'Enumeration for the data direction
Public Enum e_Direction
    SCSI_DIR_IN = 0     ' retrieve data from the drive
    SCSI_DIR_OUT = 1    ' send data to the drive
End Enum

'Enumeration for the inquiry command
Public Enum e_InquiryMethod
    INQ_VENDOR          ' get the drive vendor
    INQ_NAME            ' get the drive name
    INQ_FIRMWARE        ' get the drive revision (firmware version)
End Enum

'Enumeration for some sector modes
Public Enum e_SectorModes
    MODE_AUDIO          ' Audio (Or Mode-0) sector
    MODE_MODE1          ' Mode-1 sector
    MODE_MODE2          ' Plain Mode-2 sector
    MODE_MODE2_FORM1    ' Mode-2 Form-1 sector
    MODE_MODE2_FORM2    ' Mode-2 Form-2 sector
End Enum

'Enumeration for ReadCD flags
Public Enum e_READCD_FLAGS
    RCD_SYNC = &H80         ' read SYNC pattern
    RCD_HEADER_4BYTE = &H20 ' read the 4-byte header
    RCD_HEADER_8BYTE = &H40 ' read the 8-byte header
    RCD_USERDATA = &H10     ' read the userdata
    RCD_EDC_ECC = &H8       ' read the EDC+ECC error data
End Enum

'Enumeration for the ReadCD SubChannel flags
Public Enum e_READCD_SUBCH_FLAGS
    RCD_SUBCH_PW_RAW = &H1          ' read the raw channels P-W
    RCD_SUBCH_Q = &H2               ' read only the Q channel
    RCD_SUBCH_PW_CORRECTED = &H4    ' read channels P-W corrected and interleaved
End Enum

'Enumeration for the CD-RW blanking
Public Enum e_BLANKING_TYPE
    [Full Blank] = &H0      ' Full Blank (complete disc)
    [Quick Blank] = &H1     ' Quick Blank (Lead-In + 1st Pre-Gap)
End Enum

'Enumeration for states
Public Enum e_Status
    STAT_EMPTY          ' empty (disc, session, ...)
    STAT_INCOMPLETE     ' incomplete (disc, session, ...)
    STAT_COMPLETE       ' complete (disc, session, ...)
    STAT_UNKNWN         ' unknown (disc, session, ...)
End Enum

'Enumeration for disc sub types
Public Enum e_CD_SubType
    STYPE_CDROMDA       ' CD-ROM or CDDA
    STYPE_CDI           ' CD-I
    STYPE_XA            ' CD-XA
    STYPE_UNKNWN        ' unknown
End Enum

'Enumeration for CD types
Public Enum e_CD_Type
    TYPE_DVD_ROM        ' DVD-ROM
    TYPE_DVD_R          ' DVD-R
    TYPE_DVD_RW         ' DVD-RW
    TYPE_DVD_RAM        ' DVD-RAM
    TYPE_DVD_P_R        ' DVD+R
    TYPE_DVD_P_RW       ' DVD+RW
    TYPE_CDROM          ' CD-ROM
    TYPE_CDROM_R_RW     ' CD-ROM, CD-R or CD-RW
    TYPE_CDR            ' CD-R
    TYPE_CDRW           ' CD-RW
End Enum

'Enumeration for track modes
Public Enum e_TrackMode
    TRK_STEREOAUDIO_EMPHASIS    ' stereo audio with pre-emphasis
    TRK_STEREOAUDIO             ' stereo audio
    TRK_AUDIO_EMPHASIS          ' audio with pre-emphasis
    TRK_AUDIO                   ' audio
    TRK_DATA_UNINTERRUPTED      ' data uninterrupted
    TRK_DATA_INCREMENTAL        ' data incremental
    TRK_UNKNWN                  ' data unknown
End Enum

'Enumeration for physical drive interfaces
Public Enum e_Interfaces
    IF_SCSI                 ' SCSI
    IF_ATAPI                ' ATAPI
    IF_IEEE                 ' IEEE
    IF_UNKNWN               ' unknown
End Enum

'Enumeration for class languages
Public Enum e_Languages
    LANG_ENG                ' English
    LANG_GER                ' German
End Enum

'Enumeration for the SCSI interface
Public Enum e_SCSI_Interface
     SCSI_ASPI = True              ' ASPI (Advanced SCSI Programming Interface)
     SCSI_SPTI = False             ' SPTI (SCSI Pass Through Interface)
End Enum

'Enumeration for the drive's Loading Mechanism
Public Enum e_LoadingMechanism
    LOAD_CADDY                      ' Caddy
    LOAD_TRAY                       ' Tray
    LOAD_POPUP                      ' Popup
    LOAD_CHANGER                    ' Changer
    LOAD_UNKNWN                     ' Unknown
End Enum

'Enumeration for the DVD books
Public Enum e_DVDBooks
    VDB_DVD_ROM                     ' DVD-ROM
    VDB_DVD_RAM                     ' DVD-RAM
    VDB_DVD_R                       ' DVD-R
    VDB_DVD_RW                      ' DVD-RW
    VDB_DVD_P_RW                    ' DVD+RW
    VDB_DVD_P_R                     ' DVD+R
    VDB_UNKNWN                      ' unknown
End Enum

'Enumeration for CD-TEXT music genres (from cd-record)
Public Enum e_Genres
    GENRE_ADULT_CONTEMP = 4   ' adult contemporary
    GENRE_ALT_ROCK = 5        ' alternative rock
    GENRE_CHILDREN = 6        ' children music
    GENRE_CLASSIC = 7         ' classic
    GENRE_CHRIST_CONTEMP = 6  ' christian contemporary
    GENRE_COUNTRY = 7         ' country
    GENRE_DANCE = 8           ' dance
    GENRE_EASY_LISTENING = 9  ' easy listening
    GENRE_EROTIC = 10         ' erotic
    GENRE_FOLK = 11           ' folk
    GENRE_GOSPEL = 12         ' gospel
    GENRE_HIPHOP = 13         ' hip hop
    GENRE_JAZZ = 14           ' jazz
    GENRE_LATIN = 15          ' latin
    GENRE_MUSICAL = 16        ' musical
    GENRE_NEWAGE = 17         ' new age
    GENRE_OPERA = 18          ' opera
    GENRE_OPERETTA = 19       ' operetta
    GENRE_POP = 20            ' pop
    GENRE_RAP = 21            ' rap
    GENRE_REGGAE = 22         ' reggae
    GENRE_ROCK = 23           ' rock
    GENRE_RYTHMANDBLUES = 24  ' R'n'B
    GENRE_SOUNDEFFECTS = 25   ' sound effects
    GENRE_SPOKEN_WORD = 26    ' spoken words
    GENRE_WORLD_MUSIC = 27    ' world music
End Enum

